library ieee;
use ieee.std_logic_1164.all;

entity system_demo is port (
  in1:	in std_logic;
  in2:	in std_logic;
  clk_50:	in std_logic;
  clk_mano:	in std_logic;
  set_clk:	in std_logic;
  reset:	in std_logic;
  SetD:	inout std_logic_vector(3 downto 0);
  segment:	out std_logic_vector(7 downto 0)
			);
end system_demo;

architecture design of system_demo is

	component generic_seg is port ( 
		config_v : in std_logic_vector(2 downto 0);
      seg : out std_logic_vector(7 downto 0)
		);
	end component;

	type StateName is (RST, S0, S1, S2, S3, S4, S5, S6, S7);
	signal STATE, NextState: StateName;
	signal config_d: std_logic_vector(2 downto 0);
	signal clk: std_logic;

begin

  ds: generic_seg port map (config_d, segment);

  ReadData: process (clk)
  begin	
		if( clk'event and clk = '1') then
			if( reset = '1' ) then
				STATE <= RST;
			else
				STATE <= NextState;
			end if;
		end if;
  end process ReadData;
			
  SetConfig: process (STATE)
  	variable data : std_logic_vector(1 downto 0);
  begin
  	 SetD <= "1101";
    data:= in1 & in2;
	 case STATE is	
	 	when RST =>
			config_d <= "000";
			NextState <= S0;
      when S0 =>  
		  	config_d <= "000";
			if( data = "10" ) then
					NextState <= S1;
			else NextState <= S0;
			end if;
      when S1 =>
			config_d <= "001";
			if( data = "11" ) then
					NextState <= S2;
			elsif( data = "10" ) then
					NextState <= S6;
			else NextState <= S3;
			end if;
      when S2 =>  
			config_d <= "011";
			if( data = "11" ) then
					NextState <= S2;
			elsif( data = "10" ) then
					NextState <= S6;
			else NextState <= S3;
			end if;
      when S3 =>  
		  	config_d <= "010";
			if( data = "10" ) then
					NextState <= S1;
			else NextState <= S0;
			end if;
      when S4 =>  
		  	config_d <= "110";
			if( data = "11" ) then
					NextState <= S2;
			elsif( data = "10" ) then
					NextState <= S6;
			else NextState <= S3;
			end if;
      when S5 =>  
		  	config_d <= "111";
			if( data = "00" ) then
					NextState <= S7;
			elsif( data = "01" ) then
					NextState <= S4;
			else NextState <= S5;
			end if;
      when S6 =>  
		  	config_d <= "101";
			if( data = "00" ) then
					NextState <= S7;
			elsif( data = "01" ) then
					NextState <= S4;
			else NextState <= S5;
			end if;
      when S7 =>  
		  	config_d <= "100";
			if( data = "10" ) then
					NextState <= S1;
			else NextState <= S0;
			end if; 
		 when others =>
		 	NextState <= RST;
    end case;
  end process SetConfig;

  SetClk: process (set_clk)
  begin
	if( set_clk = '1') then
		clk <= clk_mano;
		else clk <= clk_50;
	end if;
  end process SetClk;

end design;
