library ieee;
use ieee.std_logic_1164.all;

entity generic_seg is port (
  config_v : in std_logic_vector(2 downto 0);
  seg : out std_logic_vector(7 downto 0)
  );
end generic_seg;

architecture design_seg of generic_seg is

begin
--	      a
--	      -
--	 f | g	 |b
--	      -
--	 e |   |c
--	      -	  .h
-- 	      d
-- "hgfedcba"

  SetSeg: process (config_v)
  	 variable c1 : std_logic_vector(7 downto 0) := "11110111";
    variable c2 : std_logic_vector(7 downto 0) := "10111011";
    variable c3 : std_logic_vector(7 downto 0) := "10111111";
    variable c4 : std_logic_vector(7 downto 0) := "11110011";
    variable c5 : std_logic_vector(7 downto 0) := "10111101";
    variable c6 : std_logic_vector(7 downto 0) := "11111110";
    variable c7 : std_logic_vector(7 downto 0) := "11111100";
    variable c8 : std_logic_vector(7 downto 0) := "11110001";
  begin
	  case (config_v) is	
      when "000" =>  seg <= c1 ;
      when "001" =>  seg <= c2 ;
      when "011" =>  seg <= c3 ;
      when "010" =>  seg <= c4 ;
      when "110" =>  seg <= c5 ;
      when "111" =>  seg <= c6 ;
      when "101" =>  seg <= c7 ;
      when "100" =>  seg <= c8 ;
		when others => seg <= c1;
    end case;
  end process SetSeg;

end design_seg;
